<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Teknisa\MAN\Services;
use Teknisa\MAN\Utilities;

class Cliente extends \Zeedhi\Framework\Controller\Simple {

	protected $clienteService;
	protected $salesMessage;
	protected $util;


	public function __construct(Services\Cliente $clienteService, Utilities\SalesMessage $salesMessage, Utilities\Util $util) {
		$this->clienteService 	 = $clienteService;
		$this->salesMessage      = $salesMessage;
		$this->util              = $util;
	}

    public function buscaCentroCustoCliente(Request\Filter $request, Response $response) {
        $params = $request->getFilterCriteria()->getConditions();


        $CDCLIENTE = $params[0]['value'];

        $dadosCentroDeCusto = $this->clienteService->buscaCentroCustoCliente($CDCLIENTE);

        $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('BuscaCentroCustoRepo', $dadosCentroDeCusto));
    }

	public function getClientes(Request\Filter $request, Response $response){
        $page = $request->getFilterCriteria()->getPage();

        if(isset($params[0])){
            $NMRAZSOCCLIE = $params[0]['value'];
        }else{
            $NMRAZSOCCLIE = "%%";
        }

        $pageSize = $request->getFilterCriteria()->getPageSize();
        $FIRST = $request->getFilterCriteria()->getPageSize() * ($page-1);
        $LAST = ($FIRST + $pageSize);
        if($page > 1){
            $FIRST++;
        }
        $buscaCliente   = $this->clienteService->buscaClientes($FIRST, $LAST, $NMRAZSOCCLIE);

        $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('ClientesRepo', $buscaCliente));
    }

    public function getCities(Request\Filter $request, Response $response){
        try {
            $params   = $request->getFilterCriteria()->getConditions();
            if(isset($params[0])){
                $SGESTADO = $params[0]['value'];
            }else{
                $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('CitiesRepository', array('nada' => 'nada' )));
                return 0;
            }
            if(isset($params[1])){
                $NMMUNICIPIO = $params[1]['value'];
            }else{
                $NMMUNICIPIO = "%%";
            }
            $page = $request->getFilterCriteria()->getPage();
            $pageSize = $request->getFilterCriteria()->getPageSize();
            $FIRST = $request->getFilterCriteria()->getPageSize() * ($page-1);
            $LAST = ($FIRST + $pageSize);
            if($page > 1){
                $FIRST++;
            }
            $cities = $this->locationService->getCities($SGESTADO, $NMMUNICIPIO, $FIRST, $LAST);
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('CitiesRepository', $cities));
        } catch (\Exception $e) {
            $response->addMessage(new Message($e->getMessage()));
        }
    }

}